﻿
' TODO - Main List
' --------------------------------------------------------------------

' Done version 1.5
' --------------------------------------------------------------------
'  Hi precision frequency generation with the new class AccurateTimer  

Public Class Form1

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        EventsAreEnabled = False
        Text = AppTitleAndVersion()
        '
        Combo_InitFromEnum(cmb_Method, GetType(ChangeMethods))
        cmb_Method.SelectedIndex = 0
        '
        Load_INI()
        SetChangeMethod()
        SetParams()
        '
        AccTimer.SetInterval(2)
        AccTimer.StartTimer()
        '
        Timer1.Interval = 10
        Timer1.Start()

        EventsAreEnabled = True
        Refresh()
        Me.Opacity = 1
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        EventsAreEnabled = False
        Save_INI()
        If AccTimer IsNot Nothing Then AccTimer.StopTimer()
        Slots.WriteSlot(OutSlot, NAN_Sleep)
    End Sub

    Private Sub Form_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LocationChanged
        If Not EventsAreEnabled Then Exit Sub
        LimitFormPosition(Me)
    End Sub


    ' ==============================================================
    '   SET PARAMS - Using TextChanged and CheckedChanged
    ' ==============================================================
    Private ChangedParams As Boolean
    Private Sub txt_TextChanged(ByVal sender As System.Object, _
                                ByVal e As System.EventArgs) _
                                Handles txt_OutputSlot.TextChanged, _
                                        txt_Amplitude.TextChanged, _
                                        txt_Shift.TextChanged, _
                                        chk_ConstantSpeed.CheckedChanged, _
                                        txt_MinFreq.TextChanged, _
                                        txt_Frequency.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        ChangedParams = True
        SetParams()
    End Sub

    Private Sub SetParams()
        ' ----------------------------------------------- params
        OutSlot = txt_OutputSlot.NumericValueInteger
        Amplitude = CSng(txt_Amplitude.NumericValue)
        Shift = CSng(txt_Shift.NumericValue)
        ConstantSpeed = chk_ConstantSpeed.Checked
        MinFreq = CSng(txt_MinFreq.NumericValue)
        Frequency = CSng(txt_Frequency.NumericValue)
        ' ----------------------------------------------- constant speed
        If ConstantSpeed Then
            If MinFreq > Frequency Then
                Frequency = MinFreq
                txt_Frequency.NumericValue = MinFreq
                txt_Frequency.Refresh()
            End If
            txt_Frequency.MinValue = MinFreq
            lbl_MinFreq.Enabled = True
            txt_MinFreq.Visible = True
        Else
            lbl_MinFreq.Enabled = False
            txt_MinFreq.Visible = False
            txt_Frequency.MinValue = 0.1
        End If
    End Sub

    ' ==============================================================
    '   SAVE INI - Using MouseLeave
    ' ==============================================================
    Private Sub Params_MouseLeave(ByVal sender As Object, _
                                  ByVal e As System.EventArgs) _
                                        Handles txt_OutputSlot.MouseLeave, _
                                                txt_Amplitude.MouseLeave, _
                                                txt_Shift.MouseLeave, _
                                                chk_ConstantSpeed.MouseLeave, _
                                                txt_MinFreq.MouseLeave, _
                                                txt_Frequency.MouseLeave
        If Not EventsAreEnabled Then Return
        If ChangedParams Then
            ChangedParams = False
            Save_INI()
        End If
    End Sub

    ' ==============================================================
    '  Combo Methods - Wirh SaveINI
    ' ==============================================================
    Private Sub Combo_DropDown(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_Method.DropDown
        CType(sender, ComboBox).ItemHeight = 16
    End Sub
    Private Sub Combo_DropDownClosed(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_Method.DropDownClosed
        CType(sender, ComboBox).ItemHeight = 12
        SetChangeMethod()
        Save_INI()
    End Sub
    Private Sub SetChangeMethod()
        ChangeMethod = CType(cmb_Method.SelectedIndex, ChangeMethods)
    End Sub

    ' ==============================================================================================================
    '   TrackBars
    ' ==============================================================================================================
    Private Sub MyTrackBar1_Scroll(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyTrackBar1.Scroll
        If Not EventsAreEnabled Then Return
        WriteValueToSlot(MyTrackBar1.Value)
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        If ChangeMethod <> ChangeMethods.Manual Then
            EventsAreEnabled = False
            MyTrackBar1.Value = CInt(NewValue)
            EventsAreEnabled = True
        End If
    End Sub


End Class