﻿Module Module_WaveGenerator

    Friend WithEvents AccTimer As AccurateTimer = New AccurateTimer()

    Friend Enum ChangeMethods As Int32
        Manual
        Sinusoidal
        Semi_sinusoidal
        Triangular
        Sawtooth
        Square
    End Enum
    Friend ChangeMethod As ChangeMethods

    Friend NewValue As Double
    Friend OutSlot As Int32
    Friend Amplitude As Double = 1000
    Friend Shift As Double = 500
    Friend ConstantSpeed As Boolean = False
    Friend MinFreq As Single = 210
    Friend Frequency As Double

    ' ====================================================================================================
    '   Auto Changer
    ' ====================================================================================================
    Private Sub AccTimer_TimerTick(ByVal milliseconds As Double) Handles AccTimer.TimerTick
        Const kangle As Single = 2 * Math.PI / 1000.0F

        'Static value As Single
        'value = (value + Frequency * 2) Mod 1000

        Dim value As Double
        value = (milliseconds * Frequency) Mod 1000

        Select Case ChangeMethod

            Case ChangeMethods.Sinusoidal
                NewValue = Math.Sin(value * kangle) * 500 + 500

            Case ChangeMethods.Semi_sinusoidal
                NewValue = Math.Abs(Math.Sin(value * kangle)) * 1000

            Case ChangeMethods.Triangular
                If value >= 500 Then
                    NewValue = (1000 - value) * 2
                Else
                    NewValue = value * 2
                End If

            Case ChangeMethods.Sawtooth
                NewValue = value

            Case ChangeMethods.Square
                If value >= 500 Then
                    NewValue = 1000
                Else
                    NewValue = 0
                End If

        End Select

        If ChangeMethod <> ChangeMethods.Manual Then
            If ConstantSpeed Then
                NewValue = (NewValue - 500.0F) * MinFreq / Frequency + 500
            End If
            WriteValueToSlot(NewValue)
        End If

    End Sub

    Friend Sub WriteValueToSlot(ByVal v As Double)
        v -= 500
        v = v * Amplitude / 1000.0F
        v += Shift
        Slots.WriteSlot(OutSlot, CSng(v))
    End Sub

End Module
